*--------------------------------*
*	Processing the raw data      *
*--------------------------------*


import excel ../data/experiment_raw/results_20240425.xlsx , clear
*import excel ../data/experiment_raw/results_20240425_incomplete.xlsx , clear



ren (A-K )(TOKEN START COLLECTOR EMAIL NAME ID PROMO_CODE TIME POINTS sets clause)



** Competences & whether to invite candidates

foreach  var1 in M Q U AC AG AR AV BD BH BL BP {


 local lastl = cond(strlen("`var1'") ==1 , "`var1'" , substr("`var1'",2,1))
 local firstl = cond(strlen("`var1'") ==1 , " " , substr("`var1'",1,1))  
 
 ** Find the candidates name
 local pos1 strpos("`c(ALPHA)'", "`lastl'")
 local l1 = "`firstl'" + substr("`c(ALPHA)'", `pos1' - 2, 1)


 local name = word(`l1'[1], wordcount(`l1'[1]))
 local name = subinstr("`name'" , "?" , "" , .)

 di "`name'"
 
 local vlab= substr(`l1'[1] , strpos(`l1'[1],"W") , . )
 ren `var1' komp_`name'
 label var komp_`name'  "`vlab'"
 
 local var2 = "`firstl'" + substr("`c(ALPHA)'", `pos1' + 4, 1)
 ren `var2' invite_`name'
 label var  invite_`name' "Czy Pani zdaniem nie zaproszenie `name' na rozmowę byłoby błedem"
}


local name "Natalii"
ren AZ komp_`name'
label var komp_`name'  "W skali od 0 do 100, jak oceniłaby Pani kompetencje `name'?"
 
local var2 = "`firstl'" + substr("`c(ALPHA)'", `pos1' + 4, 1)
ren BB invite_`name'
label var  invite_`name' "Czy Pani zdaniem nie zaproszenie `name' na rozmowę byłoby błedem"



local name "Bartosza"
ren Y komp_`name'
label var komp_`name'  "W skali od 0 do 100, jak oceniłaby Pani kompetencje `name'?"
 
local var2 = "`firstl'" + substr("`c(ALPHA)'", `pos1' + 4, 1)
ren AA invite_`name'
label var  invite_`name' "Czy Pani zdaniem nie zaproszenie `name' na rozmowę byłoby błedem"

local i = 0
 
foreach var in AK AL AM AN AO AP  BT BU BV BW BX BY BZ {
local ++i

local all_names Justyny Jana Adama Bartosza Anny Barbary Marty Marka Natalii Katarzyny Karola Pauliny Piotra
local name = word("`all_names'", `i' )	

ren `var' rank_`name'
 
 }

 ** Deleting the unneeded parts
drop if _n ==1

quiet destring _all , replace

foreach var of varlist _all {
		quiet count if mi(`var')
		if `r(N)' ==_N drop `var'
	
}

drop if COLLECTOR == "Kolektor" 
drop if inlist(TOKEN, "assets" , "modules")


*** Reshaping 
*----------------------

quiet reshape long komp_ rank_ invite_ , i(TOKEN)  j(cvname) string
// drop if mi(komp)
 
label var komp   "Perceived competences"
label var invite "Should we invite candidate"


 
** Respondent characteristics
*---------------------------------------------

ren (CB CD CF CH CJ)  (phd_year title part_rec discipline email)

capture drop provided_email
gen provided_email =!mi(email) & strpos(email, "@")!=0

drop email 


gen fem_respondent = COLLECTOR =="Kolektor_f"


 *** Labelling 

label var fem_respondent "Female respondent"
label var phd_year       "Year completed PhD studies"
label var discipline     "Academic field"
label var title          "Academic title"
label var part_rec       "Participation in recruitment processes"

 

label define yesno 1 "Yes" 0 "No"
label define title 1 "doktor" 2 "doktor habilitowany" 3 "profesor (uczelni)" 4 "profesor (tytularny)"  5 "odmowa odpowiedzi"

label define title_en 1 "PhD" 2 "Tenured" 3 "University professor" ///
				      4 "Full professor"  5 "No answer"

label define partic 1 "Yes" 2 "No" 3 "No answer"

label define disc 1 "obszar nauk humanistycznych"  ///
                  2 "obszar nauk społecznych"   ///
                  3 "obszar nauk ścisłych"  ///
                  4 "obszar nauk przyrodniczych" ///
                  5 "obszar nauk technicznych"  ///
                  6 "obszar nauk rolniczych, leśnych i weterynaryjnych"  ///
                  7 "obszar nauk medycznych"  ///
                  8 "obszar sztuki"

label define disc_en  1 "Humanities"         2 "Social sciences"    /// 
                      3 "Exact sciences"     4 "Life sciences" ///
                      5 "Technical sciences" 6 "Agricultural sciences" ///
					  7 "Medicine"  8 "Art" 				  
				  
 
label val title title_en
label val part_rec partic
label val discipline disc_en

foreach var of varlist invite_* {
 	label val `var' yesno
}
 
 
 


*** CV characteristics
*------------------------

gen female = inlist(cvname , "Justyny" , "Anny" , "Barbary" , "Marty" , "Natalii" , "Katarzyny" , "Pauliny" )
label def sex 0 "Male CV" 1 "Female CV"
label val female sex


encode clause, gen(treat1)
label def treats 1 "Hiring" 2 "Recruitment"	 , modify
label val treat1 treats


capture drop cv_fe
gen cv_fe     = 1 * inlist(cvname, "Anny" , "Adama")   + 2 * inlist(cvname, "Bartosza", "Barbary")
replace cv_fe = 3 * inlist(cvname, "Natalii") + 4 * inlist(cvname, "Justyny" , "Jana") if cv_fe ==0
replace cv_fe = 5 * inlist(cvname, "Marka" , "Marty")  + 6 * inlist(cvname, "Piotra" , "Pauliny") if cv_fe ==0
replace cv_fe = 7 * inlist(cvname, "Karola" , "Katarzyny") if cv_fe ==0

gen excellent = inlist(cvname, "Anny" , "Adama", "Bartosza", "Barbary", "Natalii" )
label var excellent "High quality"
label define exc 1 "Excellent" 0 "Good"
label val excellent exc

gen recruitment = inlist(cv_fe,1,2 ,4)  + 2*!inlist(cv_fe, 1, 2, 4)


* Treatment #2
egen n_women        = total(female*(!mi(komp)))   , by(TOKEN recruitment)
gen female_minority = female * (n_women == 1)  

gen one_woman       = n_women == 1
label define one_woman 0 "Female majority" 1 "Female minority"
label val one_woman one_woman


gen min_candidate     = female * (n_women == 1) + (1-female) * (n_women ==2) 
label var min_candidate "Minority"
label define min_candidate 1 "Minority" 0 "Majority" , modify
label val min_candidate min_candidate



*** Measure of quality of answers
*---------------------------------------- 

** Too fast or too slow
capture drop minutes
gen minutes = real(substr(TIME, strpos(TIME, ":")+1 , 2)) 
replace minutes = minutes + 60 * real(substr(TIME, strpos(TIME, ":")-2 , 2) )
replace minutes = . if strpos(TIME, "day")!=0

label var minutes "Time to complete survey (minutes)"


** Useless observations (recruiter provides only noise to estimation)

egen total_yes = total(invite) , by(TOKEN)
gen  all_yes = total_yes == 6
 
label var all_yes "Invited all candidates" 
 
egen max_points = max(komp) , by(TOKEN)
egen min_points = min(komp) , by(TOKEN)
gen  no_diff  = max_point == min_points
gen  diff  = max_point - min_points
 
label var no_diff "No differences between candidates" 

bys TOKEN: gen fobs =_n ==1 
 
 
*** Saving
*--------------------------

label data "Initial database from the experiment.   "
save ../data/data_ready_202340425 , replace 


exit
** Incompleter answers
gen all_missing = rowmissing(*) 
