
capture program drop Fisher_exact
program Fisher_exact

syntax varname [if] , by(varname) stat(namelist) // nreps(integer 100 )

local outcome  "`1'"
local nreps 1000
local ncols : word count `stat'
 matrix diffs = J(`nreps' +1  , `ncols' , .)
 matrix pvals = J(`nreps', `ncols', 1 )
 matrix ones = J(1 , `nreps',  1 )
preserve
capture keep `if'

* Compute the actual differences
quiet sum `outcome' if `by' ==1 , d
local i = 1
foreach name in `stat'{
		local m`i++' = r(`name')
	}	
	
quiet sum `outcome' if `by' ==0 , d
local i = 1
foreach name in `stat'{
		local n`i++' = r(`name')
	}	

forvalues icol = 1/3 {
		matrix diffs[1,`icol'] = `m`icol'' - `n`icol''
	}	

sum `by'	
local prob = `r(mean)'
set seed 100 	
forvalues irow = 1/`nreps'{
	tempvar fake
	gen `fake' = runiform()<`prob'
	
quiet sum `outcome' if `fake' ==1 , d
	local i = 1
foreach name in `stat'{
		local m`i++' = r(`name')
	}		
quiet sum `outcome' if `fake' ==0 , d
	local i = 1
foreach name in `stat'{
		local n`i++' = r(`name')
	}	
	
forvalues icol = 1/3 {
		matrix diffs[`irow' + 1 ,`icol'] = `m`icol'' - `n`icol''
		matrix pvals[`irow' ,`icol']     =  abs(diffs[`irow' + 1 ,`icol']) > abs(diffs[1, `icol'])
		}	
	
}	
	
	
matrix pvals = ones*pvals 
matrix pvals = pvals/1000	
	

end
